<?php

/**************************************************************************
PhotoPlog Lite License
===========================================================================
This software is as-is, no warranty of any kind, use at your own risk.
You are granted free use of this software. However, you are not permitted 
under any circumstances to redistribute the software, whether in whole or 
in part. Also, the 'powered by' links must remain intact and visible. Make 
sure to understand that this is *not GPL software. Do not redistribute it, 
and do not use parts of it in other software. This software is copyrighted 
in its entirety to 'calorie' a/k/a ThinkDing LLC 2005, all rights reserved.
The software author/entity are in no way responsible for your site content.
All copyright notices and 'powered by' links must not be changed or removed.
***************************************************************************/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array('photoplog');
$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer('canadminforums'))
{
	print_cp_no_permission();
}

// ############################# LOG ACTION ###############################
log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

// ##################### Start photoplog_list_worker ##################### 
function photoplog_list_worker(&$list_cats, $parentid, $spacer, &$catids, &$titles, &$parentids)
{
	global $vbphrase;

	if ($parentid < 0)
	{
		$list_cats = array("-1" => $vbphrase['photoplog_no_one']);
	}

	$n = count($catids);
	for ($i=0; $i<$n; $i++)
	{
		if ($parentid == $parentids[$i])
		{
			$list_cats["$catids[$i]"] = $spacer." ".$titles[$i]." ";
			if ($catids[$i] > 0)
			{
				photoplog_list_worker($list_cats, $catids[$i], $spacer.'--', $catids, $titles, $parentids);
			}
		}
	}
}

// ################### Start photoplog_list_categories ###################
function photoplog_list_categories(&$list_cats, $parentid = -1, $spacer = '')
{
	global $vbulletin;

	$categories = $vbulletin->db->query_read("SELECT *
				FROM photoplog_categories
				ORDER BY parentid,displayorder,catid
	");

	$catids = array();
	$titles = array();
	$parentids = array();

	while ($category = $vbulletin->db->fetch_array($categories))
	{
		$catids[] = intval($category['catid']);
		$titles[] = strval($category['title']);
		$parentids[] = intval($category['parentid']);
	}

	photoplog_list_worker($list_cats, $parentid, $spacer, $catids, $titles, $parentids);
}

$photoplog_list_categories = array();
photoplog_list_categories($photoplog_list_categories);

$photoplog_categoryoptions = array(
	'allowhtml' => 1,
	'allowsmilies' => 2,
	'allowbbcode' => 4,
	'allowimgcode' => 8,
	'allowparseurl' => 16,
	'allowcomments' => 32,
	'issearchable' => 64
);

$photoplog_ds_catquery = $db->query_first("SELECT data
					FROM " . TABLE_PREFIX . "datastore
					WHERE title = 'photoplog_dscat'
");

if (!$photoplog_ds_catquery)
{
	$photoplog_ds_catopts = array();
}
else
{
	$photoplog_ds_catopts = unserialize($photoplog_ds_catquery['data']);
}

print_cp_header($vbphrase['photoplog_category_manager']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'modify';
}

if ($_REQUEST['do'] == 'add')
{
	$photoplog_category = array(
		'title' => '',
		'description' => '',
		'displayorder' => 1,
		'parentid' => -1,
		'allowhtml' => 0,
		'allowsmilies' => 1,
		'allowbbcode' => 1,
		'allowimgcode' => 0,
		'allowparseurl' => 0,
		'allowcomments' => 1,
		'issearchable' => 1
	);

	print_form_header('photoplog_category', 'doadd');
	construct_hidden_code('s', $vbulletin->session->vars['sessionhash']);
	print_table_header($vbphrase['photoplog_add_new_category']);
	print_input_row($vbphrase['photoplog_title'], 'photoplog_category[title]', $photoplog_category['title']);
	print_textarea_row($vbphrase['photoplog_description'], 'photoplog_category[description]', $photoplog_category['description']);
	print_input_row("$vbphrase[photoplog_display_order]<dfn>$vbphrase[photoplog_zero_equals_no_display]</dfn>", 'photoplog_category[displayorder]', $photoplog_category['displayorder']);
	print_select_row($vbphrase['photoplog_parent_category'], 'photoplog_category[parentid]', $photoplog_list_categories, $photoplog_category['parentid'], true, 0, false);
	print_table_header($vbphrase['photoplog_enable_disable_features']);
	print_yes_no_row($vbphrase['photoplog_allow_html'], 'photoplog_category[options][allowhtml]', $photoplog_category['allowhtml']);
	print_yes_no_row($vbphrase['photoplog_allow_smilies'], 'photoplog_category[options][allowsmilies]', $photoplog_category['allowsmilies']);
	print_yes_no_row($vbphrase['photoplog_allow_bbcode'], 'photoplog_category[options][allowbbcode]', $photoplog_category['allowbbcode']);
	print_yes_no_row($vbphrase['photoplog_allow_img_code'], 'photoplog_category[options][allowimgcode]', $photoplog_category['allowimgcode']);
	print_yes_no_row($vbphrase['photoplog_allow_parse_url'], 'photoplog_category[options][allowparseurl]', $photoplog_category['allowparseurl']);
	print_yes_no_row($vbphrase['photoplog_allow_comments'], 'photoplog_category[options][allowcomments]', $photoplog_category['allowcomments']);
	print_yes_no_row($vbphrase['photoplog_is_searchable'], 'photoplog_category[options][issearchable]', $photoplog_category['issearchable']);
	print_submit_row($vbphrase['photoplog_save']);
}

if ($_REQUEST['do'] == 'doadd')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'photoplog_category' => TYPE_ARRAY
	));

	$photoplog_category = $vbulletin->GPC['photoplog_category'];

	$photoplog_category_title = trim(strval($photoplog_category['title']));
	$photoplog_category_description = trim(strval($photoplog_category['description']));
	$photoplog_category_displayorder = intval(trim(strval($photoplog_category['displayorder'])));
	$photoplog_category_parentid = intval(trim(strval($photoplog_category['parentid'])));

	$photoplog_category_options = $photoplog_category['options'];
	foreach ($photoplog_category_options AS $photoplog_key => $photoplog_val)
	{
		$photoplog_category_options["$photoplog_key"] = intval(trim(strval($photoplog_val)));
	}

	if (!function_exists('convert_array_to_bits'))
	{
		require_once(DIR . '/includes/functions_misc.php');
	}

	$photoplog_category_bitopts = convert_array_to_bits($photoplog_category_options, $photoplog_categoryoptions, 1);

	if (
		$db->query_write("INSERT INTO photoplog_categories
				(title, description, displayorder, parentid, options)
				VALUES (
					'".$db->escape_string($photoplog_category_title)."',
					'".$db->escape_string($photoplog_category_description)."',
					".intval($photoplog_category_displayorder).",
					".intval($photoplog_category_parentid).",
					".intval($photoplog_category_bitopts)."
				)
		")
	)
	{
		$photoplog_catid = $db->insert_id();

		$photoplog_cat_datastore = array(
				'title' => $photoplog_category_title,
				'description' => $photoplog_category_description,
				'displayorder' => $photoplog_category_displayorder,
				'parentid' => $photoplog_category_parentid,
				'options' => $photoplog_category_bitopts
		);

		$photoplog_dscatopts = $photoplog_ds_catopts;
		$photoplog_dscatopts["$photoplog_catid"] = $photoplog_cat_datastore;
		build_datastore('photoplog_dscat', serialize($photoplog_dscatopts));

//		print_cp_redirect("photoplog_category.php?".$vbulletin->session->vars['sessionurl']."do=edit&amp;catid=".$photoplog_catid, 1);
		print_cp_redirect("photoplog_category.php?".$vbulletin->session->vars['sessionurl']."do=modify", 1);
	}
	else
	{
		print_stop_message('generic_error_x', $vbphrase['photoplog_bad_cat_insert']);
	}
}

if ($_REQUEST['do'] == 'edit')
{
	$vbulletin->input->clean_array_gpc('g', array(
		'catid' => TYPE_UINT
	));

	$photoplog_catid = $vbulletin->GPC['catid'];

	$photoplog_category_info = $db->query_first("SELECT * FROM photoplog_categories
						WHERE catid = ".intval($photoplog_catid)."
	");

	if (!$photoplog_category_info)
	{
		print_stop_message(no_results_matched_your_query);
	}
	else
	{
		$photoplog_category = $photoplog_category_info;
		$photoplog_category_options = convert_bits_to_array($photoplog_category_info['options'], $photoplog_categoryoptions);

		print_form_header('photoplog_category', 'doedit');
		construct_hidden_code('s', $vbulletin->session->vars['sessionhash']);
		construct_hidden_code('catid', $photoplog_catid);
		print_table_header($vbphrase['photoplog_edit_this_category']);
		print_input_row($vbphrase['photoplog_title'], 'photoplog_category[title]', $photoplog_category['title']);
		print_textarea_row($vbphrase['photoplog_description'], 'photoplog_category[description]', $photoplog_category['description']);
		print_input_row("$vbphrase[photoplog_display_order]<dfn>$vbphrase[photoplog_zero_equals_no_display]</dfn>", 'photoplog_category[displayorder]', $photoplog_category['displayorder']);
		print_select_row($vbphrase['photoplog_parent_category'], 'photoplog_category[parentid]', $photoplog_list_categories, $photoplog_category['parentid'], true, 0, false);
		print_table_header($vbphrase['photoplog_enable_disable_features']);
		print_yes_no_row($vbphrase['photoplog_allow_html'], 'photoplog_category[options][allowhtml]', $photoplog_category_options['allowhtml']);
		print_yes_no_row($vbphrase['photoplog_allow_smilies'], 'photoplog_category[options][allowsmilies]', $photoplog_category_options['allowsmilies']);
		print_yes_no_row($vbphrase['photoplog_allow_bbcode'], 'photoplog_category[options][allowbbcode]', $photoplog_category_options['allowbbcode']);
		print_yes_no_row($vbphrase['photoplog_allow_img_code'], 'photoplog_category[options][allowimgcode]', $photoplog_category_options['allowimgcode']);
		print_yes_no_row($vbphrase['photoplog_allow_parse_url'], 'photoplog_category[options][allowparseurl]', $photoplog_category_options['allowparseurl']);
		print_yes_no_row($vbphrase['photoplog_allow_comments'], 'photoplog_category[options][allowcomments]', $photoplog_category_options['allowcomments']);
		print_yes_no_row($vbphrase['photoplog_is_searchable'], 'photoplog_category[options][issearchable]', $photoplog_category_options['issearchable']);
		print_submit_row($vbphrase['photoplog_save']);
	}
}

if ($_REQUEST['do'] == 'doedit')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid' => TYPE_UINT,
		'photoplog_category' => TYPE_ARRAY
	));

	$photoplog_catid = $vbulletin->GPC['catid'];

	$photoplog_category = $vbulletin->GPC['photoplog_category'];

	$photoplog_category_parentid = intval(trim(strval($photoplog_category['parentid'])));

	if ($photoplog_catid == $photoplog_category_parentid)
	{
		print_stop_message('generic_error_x', $vbphrase['photoplog_bad_parent']);
	}

	$photoplog_category_title = trim(strval($photoplog_category['title']));
	$photoplog_category_description = trim(strval($photoplog_category['description']));
	$photoplog_category_displayorder = intval(trim(strval($photoplog_category['displayorder'])));

	$photoplog_category_options = $photoplog_category['options'];
	foreach ($photoplog_category_options AS $photoplog_key => $photoplog_val)
	{
		$photoplog_category_options["$photoplog_key"] = intval(trim(strval($photoplog_val)));
	}

	if (!function_exists('convert_array_to_bits'))
	{
		require_once(DIR . '/includes/functions_misc.php');
	}

	$photoplog_category_bitopts = convert_array_to_bits($photoplog_category_options, $photoplog_categoryoptions, 1);

	if (
		$db->query_write("REPLACE INTO photoplog_categories
				(catid, title, description, displayorder, parentid, options)
				VALUES (
					".intval($photoplog_catid).",
					'".$db->escape_string($photoplog_category_title)."',
					'".$db->escape_string($photoplog_category_description)."',
					".intval($photoplog_category_displayorder).",
					".intval($photoplog_category_parentid).",
					".intval($photoplog_category_bitopts)."
				)
		")
	)
	{
		$photoplog_catid = intval($photoplog_catid);

		$photoplog_cat_datastore = array(
				'title' => $photoplog_category_title,
				'description' => $photoplog_category_description,
				'displayorder' => $photoplog_category_displayorder,
				'parentid' => $photoplog_category_parentid,
				'options' => $photoplog_category_bitopts
		);

		$photoplog_dscatopts = $photoplog_ds_catopts;
		$photoplog_dscatopts["$photoplog_catid"] = $photoplog_cat_datastore;
		build_datastore('photoplog_dscat', serialize($photoplog_dscatopts));

//		print_cp_redirect("photoplog_category.php?".$vbulletin->session->vars['sessionurl']."do=edit&amp;catid=".$photoplog_catid, 1);
		print_cp_redirect("photoplog_category.php?".$vbulletin->session->vars['sessionurl']."do=modify", 1);
	}
	else
	{
		print_stop_message('generic_error_x', $vbphrase['photoplog_bad_cat_replace']);
	}
}

if ($_REQUEST['do'] == 'modify')
{
		print_form_header('photoplog_category', 'doorder');
		construct_hidden_code('s', $vbulletin->session->vars['sessionhash']);
		construct_hidden_code('catid', $photoplog_catid);
		print_table_header($vbphrase['photoplog_category_manager'], 3);
		print_description_row($vbphrase['photoplog_if_you_change_display_order'], 0, 3);

		print_cells_row(array($vbphrase['photoplog_title'],
					'<nobr>' . $vbphrase['photoplog_display_order'] . '</nobr>',
					$vbphrase['photoplog_controls']), 1, '', -1);

		$photoplog_category = array();
		foreach($photoplog_list_categories AS $photoplog_key => $photoplog_value)
		{
			if ($photoplog_key > 0)
			{
				$photoplog_catid = $photoplog_key;
				$photoplog_dashes = '';
				$photoplog_title = htmlspecialchars_uni(trim($photoplog_value));

				if (eregi("^([-]+[ ])(.*)",$photoplog_title,$photoplog_regs))
				{
					$photoplog_dashes = $photoplog_regs[1];
					$photoplog_title = $photoplog_regs[2];
				}

				$photoplog_category['displayorder'] = $photoplog_ds_catopts[$photoplog_catid]['displayorder'];

				$bgclass = fetch_row_bgclass();
				echo "
					<tr>
						<td class=\"$bgclass\" width=\"100%\">".$photoplog_dashes."<a href=\"photoplog_category.php?" . $vbulletin->session->vars['sessionurl'] . "do=edit&amp;catid=".$photoplog_catid."\">".$photoplog_title."</a></td>
						<td class=\"$bgclass\"><input type=\"text\" class=\"bginput\" name=\"photoplog_category[".$photoplog_catid."]\" value=\"".$photoplog_category['displayorder']."\" size=\"5\" /></td>
						<td class=\"$bgclass\"><nobr><a href=\"photoplog_category.php?" . $vbulletin->session->vars['sessionurl'] . "do=edit&amp;catid=".$photoplog_catid."\">".$vbphrase['photoplog_edit']."</a> <a href=\"photoplog_category.php?" . $vbulletin->session->vars['sessionurl'] . "do=delete&amp;catid=".$photoplog_catid."\">".$vbphrase['photoplog_delete']."</a></nobr></td>
					</tr>
				";
			}
		}

		print_table_footer(3, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['photoplog_save_display_order'] . "\" accesskey=\"s\" />" . construct_button_code($vbphrase['photoplog_add_new_category'], "photoplog_category.php?" . $vbulletin->session->vars['sessionurl'] . "do=add"));
}

if ($_REQUEST['do'] == 'doorder')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'photoplog_category' => TYPE_ARRAY_UINT
	));

	if (!empty($vbulletin->GPC['photoplog_category']))
	{
		$photoplog_dscatopts = $photoplog_ds_catopts;

		$photoplog_sql = '';
		foreach ($vbulletin->GPC['photoplog_category'] AS $photoplog_catid => $photoplog_displayorder)
		{
			$photoplog_sql .= "WHEN " . intval($photoplog_catid) . " THEN " . intval($photoplog_displayorder) . "\n";
			$photoplog_dscatopts["$photoplog_catid"]['displayorder'] = intval($photoplog_displayorder);
		}

		if (
			$db->query_write("UPDATE photoplog_categories
					SET displayorder = CASE catid
					$photoplog_sql ELSE displayorder END
			")
		)
		{
			build_datastore('photoplog_dscat', serialize($photoplog_dscatopts));
			print_cp_redirect("photoplog_category.php?".$vbulletin->session->vars['sessionurl']."do=modify", 1);
		}
		else
		{
			print_stop_message('generic_error_x', $vbphrase['photoplog_bad_order_update']);
		}
	}
	else
	{
		print_stop_message('no_results_matched_your_query');
	}
}

if ($_REQUEST['do'] == 'delete')
{
	$vbulletin->input->clean_array_gpc('g', array(
		'catid' => TYPE_UINT
	));

	print_form_header('photoplog_category', 'dodelete');
	construct_hidden_code('s', $vbulletin->session->vars['sessionhash']);
	construct_hidden_code('catid', $vbulletin->GPC['catid']);

	print_table_header($vbphrase['photoplog_confirm_deletion']);
	print_description_row($vbphrase['photoplog_confirm_delete_category']);
	print_submit_row($vbphrase['photoplog_yes'], '', 2, $vbphrase['photoplog_no']);
}

if ($_REQUEST['do'] == 'dodelete')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid' => TYPE_UINT
	));

	$photoplog_catid = $vbulletin->GPC['catid'];
	$photoplog_dscatopts = $photoplog_ds_catopts;

	// #################### Start photoplog_child_worker #####################
	function photoplog_child_worker(&$list_all, $catid, &$catids, &$parids)
	{
		$n = count($catids);
		for ($i=0; $i<$n; $i++)
		{
			if ($catid == $parids[$i])
			{
				$list_all[] = $catids[$i];
				if ($catids[$i] > 0)
				{
					photoplog_child_worker($list_all, $catids[$i], $catids, $parids);
				}
			}
		}
	}

	// ##################### Start photoplog_child_list ######################
	function photoplog_child_list(&$list_all, $catid = -1)
	{
		global $vbulletin;

		$categories = $vbulletin->db->query_read("SELECT catid, parentid
							FROM photoplog_categories");

		$catids = array();
		$parids = array();

		while ($category = $vbulletin->db->fetch_array($categories))
		{
			$catids[] = intval($category['catid']);
			$parids[] = intval($category['parentid']);
		}

		photoplog_child_worker($list_all, $catid, $catids, $parids);
	}

	$photoplog_child_list = array();
	photoplog_child_list($photoplog_child_list, $photoplog_catid);

	$photoplog_sql = "WHERE catid = ". intval($photoplog_catid);
	unset($photoplog_dscatopts["$photoplog_catid"]);

	if (!empty($photoplog_child_list))
	{
		$photoplog_sql = "WHERE catid IN (" . intval($photoplog_catid) . "," . implode(",",$photoplog_child_list) . ")";
		foreach ($photoplog_child_list AS $photoplog_childid)
		{
			unset($photoplog_dscatopts["$photoplog_childid"]);
		}
	}

	if (
		($db->query_write("UPDATE photoplog_fileuploads
				SET catid = 0
				$photoplog_sql
		"))
			&&
		($db->query_write("UPDATE photoplog_ratecomment
				SET catid = 0
				$photoplog_sql
		"))
			&&
		($db->query_write("DELETE FROM photoplog_categories
				$photoplog_sql
		"))
	)
	{
		build_datastore('photoplog_dscat', serialize($photoplog_dscatopts));
		print_cp_redirect("photoplog_category.php?".$vbulletin->session->vars['sessionurl']."do=modify", 1);
	}
	else
	{
		print_stop_message('generic_error_x', $vbphrase['photoplog_bad_cat_delete']);
	}
}

print_cp_footer();

?>