<?php

/**************************************************************************
PhotoPlog Lite License
===========================================================================
This software is as-is, no warranty of any kind, use at your own risk.
You are granted free use of this software. However, you are not permitted 
under any circumstances to redistribute the software, whether in whole or 
in part. Also, the 'powered by' links must remain intact and visible. Make 
sure to understand that this is *not GPL software. Do not redistribute it, 
and do not use parts of it in other software. This software is copyrighted 
in its entirety to 'calorie' a/k/a ThinkDing LLC 2005, all rights reserved.
The software author/entity are in no way responsible for your site content.
All copyright notices and 'powered by' links must not be changed or removed.
***************************************************************************/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array('photoplog');
$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer('canadminforums'))
{
	print_cp_no_permission();
}

// ############################# LOG ACTION ###############################
log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

$photoplog_location = $vbulletin->options['photoplog_script_dir'];

print_cp_header($vbphrase['photoplog_moderate_comments']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'modify';
}

if ($_REQUEST['do'] == 'modify')
{
	$photoplog_moderate_comments = $db->query_read("SELECT *
						FROM photoplog_ratecomment
						WHERE moderate = 1
						ORDER BY dateline DESC
	");

	if ($photoplog_moderate_comments)
	{
		print_form_header('photoplog_comment', 'approve');
		construct_hidden_code('s', $vbulletin->session->vars['sessionhash']);
		print_table_header($vbphrase['photoplog_moderate_comments'], 3);

		print_cells_row(array('<nobr>' . $vbphrase[photoplog_username] . ' / ' . $vbphrase['photoplog_comment'] . '</nobr>',
					'<nobr>' . $vbphrase['photoplog_check_to_approve'] . '</nobr>'), 1, '', -1);

		$photoplog_cnt_bits = 0;

		while ($photoplog_moderate_comment = $vbulletin->db->fetch_array($photoplog_moderate_comments))
		{
			$photoplog_cnt_bits++;

			$photoplog_commentid = $photoplog_moderate_comment['commentid'];
			$photoplog_fileid = $photoplog_moderate_comment['fileid'];

			$photoplog_comment_count = $db->query_first("SELECT COUNT(*) AS num
										FROM photoplog_ratecomment
										WHERE fileid = ".intval($photoplog_fileid)."
			");

			if (!$photoplog_comment_count['num'])
			{
				$photoplog_comment_count['num'] = 1;
			}

			$photoplog_comment_page = ceil($photoplog_comment_count['num'] / 5);
			$photoplog_comment_page = '&amp;page='.$photoplog_comment_page.'#comment'.$photoplog_commentid;

			$photoplog_rating = $photoplog_moderate_comment['rating'];
			$photoplog_rating = "<img style=\"float: right;\" src=\"".$photoplog_location."/stars/rating_".$photoplog_rating.".gif\" border=\"0\" />";

			$photoplog_userid = $photoplog_moderate_comment['userid'];
			$photoplog_username = "<a href=\"".$vbulletin->options['bburl']."/member.php?".$vbulletin->session->vars['sessionurl']."u=".$photoplog_userid."\" target=\"_blank\">".$photoplog_moderate_comment['username']."</a>";

			$photoplog_date = vbdate($vbulletin->options['dateformat'],$photoplog_moderate_comment['dateline']);
			$photoplog_time = vbdate($vbulletin->options['timeformat'],$photoplog_moderate_comment['dateline']);

			$photoplog_click = "<strong>[<a href=\"".$photoplog_location."/index.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid.$photoplog_comment_page."\" target=\"_blank\">". $vbphrase['photoplog_click_here_to_delete'] ."</a>]</strong>";

			$photoplog_thumb = "<img src=\"".$photoplog_location."/file.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid."&amp;w=s\" border=\"0\" />";
			$photoplog_thumb = "<div style=\"float: right;\">".$photoplog_rating."<br /><a style=\"float: right;\" href=\"".$photoplog_location."/index.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid.$photoplog_comment_page."\" target=\"_blank\">".$photoplog_thumb."</a></div>";

			$photoplog_title = htmlspecialchars_uni($photoplog_moderate_comment['title']);
			$photoplog_comment = htmlspecialchars_uni($photoplog_moderate_comment['comment']);

			$photoplog_file_info = $db->query_first("SELECT *
										FROM photoplog_fileuploads
										WHERE fileid = ".intval($photoplog_fileid)."
			");

			if (empty($photoplog_title))
			{
				if ($photoplog_file_info['title'])
				{
					$photoplog_title = htmlspecialchars_uni($photoplog_file_info['title']);
				}
				else
				{
					$photoplog_title = $vbphrase['photoplog_untitled'];
				}
			}

			if (empty($photoplog_comment))
			{
				$photoplog_comment = $vbphrase['photoplog_not_available'];
			}
			$photoplog_comment = "<a href=\"".$photoplog_location."/index.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid.$photoplog_comment_page."\" target=\"_blank\">".$photoplog_title."</a><br /><br />".$photoplog_comment;

			echo "
				<tr><td colspan=\"2\" class=\"tcat\">".$vbphrase['photoplog_posted_by']." ".$photoplog_username." ".$photoplog_date." ".$photoplog_time." ".$photoplog_click."</td></tr>
			";

			$photoplog_file_moderate = $photoplog_file_info['moderate'];

			if (!$photoplog_file_moderate)
			{
				print_checkbox_row($photoplog_comment, "photoplog_approve[$photoplog_commentid]", false, 1, $photoplog_thumb, '');
			}
			else
			{
				$photoplog_moderate_msg = "<a href=\"photoplog_file.php?".$vbulletin->session->vars['sessionurl']."do=modify\">".$vbphrase['photoplog_approve_file']."</a>";
				print_description_row($photoplog_moderate_msg.$photoplog_thumb, 0, 2);
			}
		}

		if ($photoplog_cnt_bits)
		{
			print_submit_row($vbphrase['photoplog_save']);
		}
		else
		{
			print_description_row($vbphrase['photoplog_nothing_to_moderate'], 0, 2);
			print_table_footer();
		}
	}
	else
	{
		print_form_header('', '');
		construct_hidden_code('s', $vbulletin->session->vars['sessionhash']);
		print_table_header($vbphrase['photoplog_moderate_comments'], 1);
		print_description_row($vbphrase['photoplog_bad_luck'], 0, 2);
		print_table_footer();
	}
}

if ($_REQUEST['do'] == 'approve')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'photoplog_approve' => TYPE_ARRAY_UINT
	));

	$photoplog_approve = $vbulletin->GPC['photoplog_approve'];
	$photoplog_approved_commentids = array();

	foreach ($photoplog_approve AS $photoplog_key => $photoplog_value)
	{
		$photoplog_commentid = intval(trim($photoplog_key));
		$photoplog_approved = intval(trim($photoplog_value));

		if ($photoplog_approved)
		{
			$photoplog_approved_commentids[] = $photoplog_commentid;
		}
	}

	$photoplog_sql_in = implode(",",$photoplog_approved_commentids);

	if (!empty($photoplog_sql_in))
	{
		$db->query_write("UPDATE photoplog_ratecomment
					SET moderate = 0
					WHERE commentid IN (".$photoplog_sql_in.")
		");
	}

	print_cp_redirect("photoplog_comment.php?".$vbulletin->session->vars['sessionurl']."do=modify", 1);
}

print_cp_footer();

?>