<?php

/**************************************************************************
PhotoPlog Lite License
===========================================================================
This software is as-is, no warranty of any kind, use at your own risk.
You are granted free use of this software. However, you are not permitted 
under any circumstances to redistribute the software, whether in whole or 
in part. Also, the 'powered by' links must remain intact and visible. Make 
sure to understand that this is *not GPL software. Do not redistribute it, 
and do not use parts of it in other software. This software is copyrighted 
in its entirety to 'calorie' a/k/a ThinkDing LLC 2005, all rights reserved.
The software author/entity are in no way responsible for your site content.
All copyright notices and 'powered by' links must not be changed or removed.
***************************************************************************/

// #################### PREVENT UNAUTHORIZED USERS ########################
if (!defined('PHOTOPLOG_SCRIPT'))
{
	exit();
}

// ###################### CHECK LAST DATELINES ############################
$photoplog_date_info = $db->query_first("SELECT MAX(photoplog_fileuploads.dateline) AS max1,
						MAX(photoplog_ratecomment.dateline) AS max2
						FROM photoplog_fileuploads LEFT JOIN photoplog_ratecomment
						ON (photoplog_fileuploads.fileid = photoplog_ratecomment.fileid)
");

$photoplog_fumax_date = TIMENOW;
$photoplog_rcmax_date = TIMENOW;
$photoplog_tnmax_date = TIMENOW;

if ($photoplog_date_info)
{
	$photoplog_fumax_date = intval($photoplog_date_info['max1']);
	$photoplog_rcmax_date = intval($photoplog_date_info['max2']);
}

$db->free_result($photoplog_date_info);

if (!empty($photoplog_ds_indopts))
{
	$photoplog_ds_fumax = 0;
	$photoplog_ds_rcmax = 0;
	$photoplog_ds_tnmax = 0;

	foreach ($photoplog_ds_indopts AS $photoplog_ds_indopts_catid => $photoplog_ds_indopts_infos)
	{
		if (
			isset($photoplog_ds_indopts_infos['photoplog_last_upload']['dateline'])
				&&
			intval($photoplog_ds_indopts_infos['photoplog_last_upload']['dateline']) > $photoplog_ds_fumax
		)
		{
			$photoplog_ds_fumax = intval($photoplog_ds_indopts_infos['photoplog_last_upload']['dateline']);
		}
		if (
			isset($photoplog_ds_indopts_infos['photoplog_last_comment']['dateline'])
				&&
			intval($photoplog_ds_indopts_infos['photoplog_last_comment']['dateline']) > $photoplog_ds_rcmax
		)
		{
			$photoplog_ds_rcmax = intval($photoplog_ds_indopts_infos['photoplog_last_comment']['dateline']);
		}
		if (
			isset($photoplog_ds_indopts_infos['photoplog_last_dsind_time']['dateline'])
				&&
			intval($photoplog_ds_indopts_infos['photoplog_last_dsind_time']['dateline']) > $photoplog_ds_tnmax
		)
		{
			$photoplog_ds_tnmax = intval($photoplog_ds_indopts_infos['photoplog_last_dsind_time']['dateline']);
		}
	}

	$photoplog_cache_cats = max(0,intval($vbulletin->options['photoplog_cache_cats']));

	if (
		(
			$vbulletin->options['photoplog_update_cats']
				&&
			(
				$photoplog_fumax_date != $photoplog_ds_fumax
					||
				$photoplog_rcmax_date != $photoplog_ds_rcmax
			)
		)
			||
		$photoplog_tnmax_date - $photoplog_cache_cats >= $photoplog_ds_tnmax
	)
	{
		$photoplog_ds_tnmax = TIMENOW;
		$photoplog_ds_indopts = array();
	}

	unset($photoplog_ds_indopts_catid, $photoplog_ds_indopts_infos);
}

// ##################### INITIALIZE CATEGORY BITS #########################
$photoplog_catbit_info = array();
$photoplog_ind_datastore = array();

$photoplog_cache_sql1 = "AND photoplog_fileuploads.moderate = 0";
$photoplog_cache_sql2 = "AND photoplog_ratecomment.moderate = 0";
$photoplog_cache_sql3 = "AND IFNULL(photoplog_ratecomment.moderate,0) = 0";

foreach ($photoplog_ds_catopts AS $photoplog_ds_catid => $photoplog_ds_value)
{
	if ($photoplog_ds_catopts[$photoplog_ds_catid]['parentid'] < 0)
	{
		$photoplog_count_cats_coms = array();
		$photoplog_last_upload = array();
		$photoplog_last_comment = array();
		$photoplog_last_comment_info = array();

		$photoplog_child_list = array();
		if (isset($photoplog_list_relatives[$photoplog_ds_catid]))
		{
			$photoplog_child_list = $photoplog_list_relatives[$photoplog_ds_catid];
		}

		$photoplog_sql1 = "WHERE photoplog_fileuploads.catid = ". intval($photoplog_ds_catid);
		if (!empty($photoplog_child_list))
		{
			$photoplog_sql1 = "WHERE photoplog_fileuploads.catid IN (" . intval($photoplog_ds_catid) . "," . implode(",",$photoplog_child_list) . ")";
		}

		$photoplog_sql2 = "WHERE photoplog_ratecomment.catid = ". intval($photoplog_ds_catid);
		if (!empty($photoplog_child_list))
		{
			$photoplog_sql2 = "WHERE photoplog_ratecomment.catid IN (" . intval($photoplog_ds_catid) . "," . implode(",",$photoplog_child_list) . ")";
		}

		$photoplog_upload_count = 0;
		$photoplog_comment_count = 0;

		if (empty($photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_count_cats_coms']))
		{
			$photoplog_count_cats_coms = $db->query_first("SELECT
							COUNT(DISTINCT photoplog_fileuploads.fileid) AS num1,
							COUNT(photoplog_ratecomment.commentid) AS num2
							FROM photoplog_fileuploads
							LEFT JOIN photoplog_ratecomment
							ON (photoplog_ratecomment.fileid = photoplog_fileuploads.fileid)
							$photoplog_sql1
							$photoplog_cache_sql1
							$photoplog_cache_sql3
			");
		}
		else
		{
			$photoplog_count_cats_coms = $photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_count_cats_coms'];
		}

		$photoplog_upload_count = $photoplog_count_cats_coms['num1'];
		$photoplog_comment_count = $photoplog_count_cats_coms['num2'];
		$db->free_result($photoplog_count_cats_coms);

		$photoplog_catbit_displayorder = $photoplog_ds_catopts[$photoplog_ds_catid]['displayorder'];
		while (in_array($photoplog_catbit_displayorder,array_keys($photoplog_catbit_info)))
		{
			$photoplog_catbit_displayorder++;
		}
		$photoplog_catbit_title = $photoplog_ds_catopts[$photoplog_ds_catid]['title'];
		$photoplog_catbit_description = $photoplog_ds_catopts[$photoplog_ds_catid]['description'];

		$photoplog_catbit_info[$photoplog_catbit_displayorder]['title'] = $photoplog_catbit_title;
		$photoplog_catbit_info[$photoplog_catbit_displayorder]['description'] = $photoplog_catbit_description;
		$photoplog_catbit_info[$photoplog_catbit_displayorder]['count1'] = $photoplog_upload_count;
		$photoplog_catbit_info[$photoplog_catbit_displayorder]['count2'] = $photoplog_comment_count;
		$photoplog_catbit_info[$photoplog_catbit_displayorder]['catid'] = $photoplog_ds_catid;

		$photoplog_catbit_info[$photoplog_catbit_displayorder]['subcats'] = '';
		$photoplog_catbit_info_temp = array();

		$photoplog_child_list = array();
		if (isset($photoplog_list_children[$photoplog_ds_catid]))
		{
			$photoplog_child_list = $photoplog_list_children[$photoplog_ds_catid];
		}

		foreach ($photoplog_child_list AS $photoplog_cl_value)
		{
			$photoplog_catbit_displayorder_temp = $photoplog_ds_catopts[$photoplog_cl_value]['displayorder'];
			while (in_array($photoplog_catbit_displayorder_temp,array_keys($photoplog_catbit_info_temp)))
			{
				$photoplog_catbit_displayorder_temp++;
			}
			$photoplog_catbit_info_temp[$photoplog_catbit_displayorder_temp] = "&nbsp;<img src=\"".$stylevar['imgdir_statusicon']."/post_old.gif\" alt=\"".$vbphrase['photoplog_image']."\" title=\"".$vbphrase['photoplog_image']."\" border=\"0\" />&nbsp;<a href=\"".$photoplog_location."/index.php?".$vbulletin->session->vars['sessionurl']."c=".$photoplog_cl_value."\">".htmlspecialchars_uni($photoplog_ds_catopts[$photoplog_cl_value]['title'])."</a>";
		}

		if (!empty($photoplog_catbit_info_temp))
		{
			ksort($photoplog_catbit_info_temp);
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['subcats'] = implode("",$photoplog_catbit_info_temp);
		}

		if ($photoplog_upload_count)
		{
			if (empty($photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_last_upload']))
			{
				$photoplog_last_upload = $db->query_first("SELECT *
								FROM photoplog_fileuploads
								$photoplog_sql1
								$photoplog_cache_sql1
								ORDER BY dateline DESC
								LIMIT 1
				");
			}
			else
			{
				$photoplog_last_upload = $photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_last_upload'];
			}

			$photoplog_lu_fileid = '';
			$photoplog_lu_userid = '';
			$photoplog_lu_username = '';
			$photoplog_lu_title = '';
			$photoplog_lu_date = '';
			$photoplog_lu_time = '';

			if ($photoplog_last_upload)
			{
				$photoplog_lu_fileid = $photoplog_last_upload['fileid'];
				$photoplog_lu_userid = $photoplog_last_upload['userid'];
				$photoplog_lu_username = $photoplog_last_upload['username'];
				$photoplog_lu_title = $photoplog_last_upload['title'];
				$photoplog_lu_date = vbdate($vbulletin->options['dateformat'],$photoplog_last_upload['dateline']);
				$photoplog_lu_time = vbdate($vbulletin->options['timeformat'],$photoplog_last_upload['dateline']);
			}

			$db->free_result($photoplog_last_upload);

			$photoplog_catbit_info[$photoplog_catbit_displayorder]['fileid1'] = $photoplog_lu_fileid;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['userid1'] = $photoplog_lu_userid;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['username1'] = $photoplog_lu_username;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['lasttitle1'] = $photoplog_lu_title;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['date1'] = $photoplog_lu_date;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['time1'] = $photoplog_lu_time;
		}

		if ($photoplog_comment_count)
		{
			if (empty($photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_last_comment']))
			{
				$photoplog_last_comment = $db->query_first("SELECT *
								FROM photoplog_ratecomment
								$photoplog_sql2
								$photoplog_cache_sql2
								ORDER BY dateline DESC
								LIMIT 1
				");
			}
			else
			{
				$photoplog_last_comment = $photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_last_comment'];
			}

			$photoplog_lc_fileid = '';
			$photoplog_lc_userid = '';
			$photoplog_lc_username = '';
			$photoplog_lc_title = '';
			$photoplog_lc_date = '';
			$photoplog_lc_time = '';
			$photoplog_lc_pagenum = '';
			$photoplog_lc_commentid = '';
			$photoplog_lc_page = '';
			$photoplog_lc_docoms = 0;

			if ($photoplog_last_comment)
			{
				$photoplog_lc_fileid = $photoplog_last_comment['fileid'];

				$photoplog_lc_catid = $photoplog_last_comment['catid'];
				if (in_array($photoplog_lc_catid,array_keys($photoplog_ds_catopts)))
				{
					$photoplog_categorybit = $photoplog_ds_catopts["$photoplog_lc_catid"]['options'];
					$photoplog_catoptions = convert_bits_to_array($photoplog_categorybit, $photoplog_categoryoptions);

					$photoplog_lc_docoms = ($photoplog_catoptions['allowcomments']) ? 1 : 0;
				}

				if (empty($photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_last_comment_info']))
				{
					$photoplog_last_comment_info = $db->query_first("SELECT COUNT(*) AS num,
													MAX(commentid) AS com
													FROM photoplog_ratecomment
													WHERE fileid = ".intval($photoplog_lc_fileid)."
													$photoplog_cache_sql2
					");
				}
				else
				{
					$photoplog_last_comment_info = $photoplog_ds_indopts[$photoplog_ds_catid]['photoplog_last_comment_info'];
				}

				if ($photoplog_last_comment_info['com'] && $photoplog_last_comment_info['num'])
				{
					$photoplog_lc_pagenum = '&amp;page='.ceil($photoplog_last_comment_info['num'] / 5);
					$photoplog_lc_commentid = '#comment'.$photoplog_last_comment_info['com'];
				}

				$photoplog_lc_page = $photoplog_lc_pagenum.$photoplog_lc_commentid;

				$db->free_result($photoplog_last_comment_info);

				$photoplog_lc_userid = $photoplog_last_comment['userid'];
				$photoplog_lc_username = $photoplog_last_comment['username'];
				$photoplog_lc_title = $photoplog_last_comment['title'];
				$photoplog_lc_date = vbdate($vbulletin->options['dateformat'],$photoplog_last_comment['dateline']);
				$photoplog_lc_time = vbdate($vbulletin->options['timeformat'],$photoplog_last_comment['dateline']);
			}

			$db->free_result($photoplog_last_comment);

			$photoplog_catbit_info[$photoplog_catbit_displayorder]['fileid2'] = $photoplog_lc_fileid;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['userid2'] = $photoplog_lc_userid;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['username2'] = $photoplog_lc_username;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['lasttitle2'] = $photoplog_lc_title;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['date2'] = $photoplog_lc_date;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['time2'] = $photoplog_lc_time;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['page2'] = $photoplog_lc_page;
			$photoplog_catbit_info[$photoplog_catbit_displayorder]['docoms2'] = $photoplog_lc_docoms;
		}

		$photoplog_ind_datastore[$photoplog_ds_catid] = array(
			'photoplog_count_cats_coms' => $photoplog_count_cats_coms,
			'photoplog_last_upload' => $photoplog_last_upload,
			'photoplog_last_comment' => $photoplog_last_comment,
			'photoplog_last_comment_info' => $photoplog_last_comment_info,
			'photoplog_last_dsind_time' => array('dateline' => $photoplog_ds_tnmax)
		);
	}
}

$photoplog_dsindopts = serialize($photoplog_ind_datastore);
if (md5(serialize($photoplog_ds_indopts)) != md5($photoplog_dsindopts))
{
	build_datastore('photoplog_dsind', $photoplog_dsindopts);
}

unset($photoplog_count_cats_coms, $photoplog_last_upload, $photoplog_last_comment, $photoplog_last_comment_info);
unset($photoplog_ind_datastore, $photoplog_dsindopts);

if (!empty($photoplog_catbit_info))
{
	ksort($photoplog_catbit_info);

	$photoplog_catbit_title = '';
	$photoplog_catbit_description = '';
	$photoplog_upload_count = '';
	$photoplog_comment_count = '';
	$photoplog_catbit_catid = '';
	$photoplog_catbit_subcats = '';

	foreach($photoplog_catbit_info AS $photoplog_key => $photoplog_value)
	{
		$photoplog_catbit_title = htmlspecialchars_uni($photoplog_catbit_info[$photoplog_key]['title']);
		$photoplog_catbit_description = $photoplog_catbit_info[$photoplog_key]['description'];
		$photoplog_upload_count = $photoplog_catbit_info[$photoplog_key]['count1'];
		$photoplog_comment_count = $photoplog_catbit_info[$photoplog_key]['count2'];
		$photoplog_catbit_catid = $photoplog_catbit_info[$photoplog_key]['catid'];
		$photoplog_catbit_subcats = $photoplog_catbit_info[$photoplog_key]['subcats'];

		if (!empty($photoplog_catbit_subcats))
		{
			$photoplog_catbit_subcats = "<div class=\"smallfont\">&nbsp;".$vbphrase['photoplog_sub_categories'].":".$photoplog_catbit_subcats."</div>";
		}

		$photoplog_catbit_fileid1 = '';
		$photoplog_catbit_userid1 = '';
		$photoplog_catbit_username1 = '';
		$photoplog_catbit_lasttitle1 = '';
		$photoplog_catbit_date1 = '';
		$photoplog_catbit_time1 = '';

		if ($photoplog_upload_count && !empty($photoplog_catbit_info[$photoplog_key]['fileid1']))
		{
			$photoplog_catbit_fileid1 = $photoplog_catbit_info[$photoplog_key]['fileid1'];
			$photoplog_catbit_userid1 = $photoplog_catbit_info[$photoplog_key]['userid1'];
			$photoplog_catbit_username1 = $photoplog_catbit_info[$photoplog_key]['username1'];
			$photoplog_catbit_lasttitle1 = $photoplog_catbit_info[$photoplog_key]['lasttitle1'];
			$photoplog_catbit_date1 = $photoplog_catbit_info[$photoplog_key]['date1'];
			$photoplog_catbit_time1 = $photoplog_catbit_info[$photoplog_key]['time1'];

			$photoplog_add_dots = false;
			if ($vbulletin->options['lastthreadchars'] != 0 && vbstrlen($photoplog_catbit_lasttitle1) > $vbulletin->options['lastthreadchars'])
			{
				$photoplog_add_dots = true;
				$photoplog_catbit_lasttitle1 = substr($photoplog_catbit_lasttitle1, 0, $vbulletin->options['lastthreadchars']);
				$photoplog_catbit_lasttitle1 = photoplog_regexp_text($photoplog_catbit_lasttitle1);
			}
			$photoplog_catbit_lasttitle1 = photoplog_process_text($photoplog_catbit_lasttitle1, $photoplog_catbit_catid, true, $photoplog_add_dots);

			if ($photoplog_catbit_lasttitle1 == $vbphrase['photoplog_not_available'])
			{
				$photoplog_catbit_lasttitle1 = $vbphrase['photoplog_untitled'];
			}
		}

		$photoplog_catbit_fileid2 = '';
		$photoplog_catbit_userid2 = '';
		$photoplog_catbit_username2 = '';
		$photoplog_catbit_lasttitle2 = '';
		$photoplog_catbit_date2 = '';
		$photoplog_catbit_time2 = '';
		$photoplog_catbit_page2 = '';
		$photoplog_do_comments = 0;

		if ($photoplog_comment_count && !empty($photoplog_catbit_info[$photoplog_key]['fileid2']))
		{
			$photoplog_catbit_fileid2 = $photoplog_catbit_info[$photoplog_key]['fileid2'];
			$photoplog_catbit_userid2 = $photoplog_catbit_info[$photoplog_key]['userid2'];
			$photoplog_catbit_username2 = $photoplog_catbit_info[$photoplog_key]['username2'];
			$photoplog_catbit_lasttitle2 = $photoplog_catbit_info[$photoplog_key]['lasttitle2'];
			$photoplog_catbit_date2 = $photoplog_catbit_info[$photoplog_key]['date2'];
			$photoplog_catbit_time2 = $photoplog_catbit_info[$photoplog_key]['time2'];
			$photoplog_catbit_page2 = $photoplog_catbit_info[$photoplog_key]['page2'];
			$photoplog_do_comments = $photoplog_catbit_info[$photoplog_key]['docoms2'];

			$photoplog_add_dots = false;
			if ($vbulletin->options['lastthreadchars'] != 0 && vbstrlen($photoplog_catbit_lasttitle2) > $vbulletin->options['lastthreadchars'])
			{
				$photoplog_add_dots = true;
				$photoplog_catbit_lasttitle2 = substr($photoplog_catbit_lasttitle2, 0, $vbulletin->options['lastthreadchars']);
				$photoplog_catbit_lasttitle2 = photoplog_regexp_text($photoplog_catbit_lasttitle2);
			}
			$photoplog_catbit_lasttitle2 = photoplog_process_text($photoplog_catbit_lasttitle2, $photoplog_catbit_catid, true, $photoplog_add_dots);

			if ($photoplog_catbit_lasttitle2 == $vbphrase['photoplog_not_available'])
			{
				$photoplog_catbit_lasttitle2 = $vbphrase['photoplog_untitled'];
			}
		}

		eval('$photoplog_cat_bits .= "' . fetch_template('photoplog_cat_bit') . '";');
	}
}
else
{
	$photoplog_cat_bits = '<tr><td colspan="5" class="alt2">'.$vbphrase['photoplog_not_available'].'</td></tr>';
}

eval('$photoplog_cat_list = "' . fetch_template('photoplog_cat_list') . '";');

?>