<?php

/**************************************************************************
PhotoPlog Lite License
===========================================================================
This software is as-is, no warranty of any kind, use at your own risk.
You are granted free use of this software. However, you are not permitted 
under any circumstances to redistribute the software, whether in whole or 
in part. Also, the 'powered by' links must remain intact and visible. Make 
sure to understand that this is *not GPL software. Do not redistribute it, 
and do not use parts of it in other software. This software is copyrighted 
in its entirety to 'calorie' a/k/a ThinkDing LLC 2005, all rights reserved.
The software author/entity are in no way responsible for your site content.
All copyright notices and 'powered by' links must not be changed or removed.
***************************************************************************/

// ################## Start photoplog_create_thumbs ######################
function photoplog_create_thumbs($file_info, $file_dir, $file_name, $new_size, $jpg_qual, $sub_dir)
{
	$file_loc = $file_dir."/".$file_name;
	$old_img = '';
	$size_arr = explode(",",str_replace(" ","",$new_size));

	if (count($size_arr) == 2)
	{
		$new_w = intval($size_arr[0]);
		$new_h = intval($size_arr[1]);
	}
	else
	{
		return false;
	}

	if ($file_info[2] == '1')
	{
		if (imagetypes() & IMG_GIF)
		{
			$old_img = @imagecreatefromgif($file_loc);
		}
	}

	if ($file_info[2] == '2')
	{
		if (imagetypes() & IMG_JPG)
		{
			$old_img = @imagecreatefromjpeg($file_loc);
		}
	}

	if ($file_info[2] == '3')
	{
		if (imagetypes() & IMG_PNG)
		{
			$old_img = @imagecreatefrompng($file_loc);
		}
	}

	if (!$old_img)
	{
		return false;
	}
	else
	{
		$orig_w = max(1,$file_info[0]);
		$orig_h = max(1,$file_info[1]);
		$new_w = max(1,$new_w);
		$new_h = max(1,$new_h);

		$ratio_w = $new_w / $orig_w;
		$ratio_h = $new_h / $orig_h;
		$ratio_m = min($ratio_w,$ratio_h);

		if ($ratio_m >= 1)
		{
			$use_w = $orig_w;
			$use_h = $orig_h;
		}
		else
		{
			$use_w = round($orig_w * $ratio_m, 0);
			$use_h = round($orig_h * $ratio_m, 0);
		}

		if ($file_info[2] == '2' || $file_info[2] == '3')
		{
			$new_img = @imagecreatetruecolor($use_w,$use_h);

			if ($file_info[2] == '3')
			{
				@imagealphablending($new_img, false);
				@imagesavealpha($new_img, true);
				$black = @imagecolorallocate($new_img,0,0,0);
				@imagecolortransparent($new_img,$black);
			}
		}
		else
		{
			$new_img = @imagecreate($use_w,$use_h);
			$black = @imagecolorallocate($new_img,0,0,0);
			@imagecolortransparent($new_img,$black);
		}

		if (!$new_img)
		{
			return false;
		}

		$out_img = @imagecopyresampled($new_img,$old_img,0,0,0,0,$use_w,$use_h,$orig_w,$orig_h);

		if (!$out_img)
		{
			return false;
		}

		$new_dir = $file_dir."/".$sub_dir;

		if (!is_dir($new_dir))
		{
			@mkdir($new_dir,0777);
			@chmod($new_dir,0777);

			if ($photoplog_handle = @fopen($new_dir."/index.html","w"))
			{
				$photoplog_blank = '';
				@fwrite($photoplog_handle,$photoplog_blank);
				@fclose($photoplog_handle);
			}
			else
			{
				return false;
			}
		}

		$file_loc = $new_dir."/".$file_name;

		$response = false;

		if ($file_info[2] == '1')
		{
			$response = imagegif($new_img,$file_loc);
		}

		if ($file_info[2] == '2')
		{
			$jpg_qual = intval($jpg_qual);
			if ($jpg_qual < 0 || $jpg_qual > 100)
			{
				$jpg_qual = 75;
			}
			$response = imagejpeg($new_img,$file_loc,$jpg_qual);
		}

		if ($file_info[2] == '3')
		{
			$response = imagepng($new_img,$file_loc);
		}

		@imagedestroy($old_img);
		@imagedestroy($new_img);

		return $response;
	}
}

// #################### Start photoplog_preg_quote #######################
function photoplog_preg_quote(&$item, $key, $prefix)
{
	$item = '/(' . preg_quote(trim($item), '/') . ')/siU';
}

// #################### Start photoplog_trim_text ########################
function photoplog_trim_text(&$item, $key, $prefix)
{
	$item = trim($item);
}

// #################### Start photoplog_process_text #####################
function photoplog_process_text($text, $catid, $is_title = false, $add_dots = false)
{
	global $vbulletin, $vbphrase, $photoplog_categoryoptions, $photoplog_ds_catopts;

	$do_html = false;
	$do_smilies = false;
	$do_bbcode = false;
	$do_imgcode = false;
	$do_parseurl = false;
//	$do_comments = false;
//	$do_searches = false;

	if (in_array($catid,array_keys($photoplog_ds_catopts)))
	{
		$photoplog_categorybit = $photoplog_ds_catopts["$catid"]['options'];
		$photoplog_catoptions = convert_bits_to_array($photoplog_categorybit, $photoplog_categoryoptions);

		$do_html = ($photoplog_catoptions['allowhtml']) ? true : false;
		$do_smilies = ($photoplog_catoptions['allowsmilies']) ? true : false;
		$do_bbcode = ($photoplog_catoptions['allowbbcode']) ? true : false;
		$do_imgcode = ($photoplog_catoptions['allowimgcode']) ? true : false;
		$do_parseurl = ($photoplog_catoptions['allowparseurl']) ? true : false;
//		$do_comments = ($photoplog_catoptions['allowcomments']) ? true : false;
//		$do_searches = ($photoplog_catoptions['issearchable']) ? true : false;
	}

	$text = fetch_censored_text($text);
	$text = fetch_word_wrapped_string($text);

	if (!function_exists('convert_url_to_bbcode'))
	{
		require_once(DIR . '/includes/functions_newpost.php');
	}

	if ($is_title)
	{
		$text = fetch_no_shouting_text($text);

		$max_len = 255;
		if (vbstrlen($text) > $max_len)
		{
			$text = substr($text, 0, $max_len);
			$text = photoplog_regexp_text($text);
		}

		if ($add_dots)
		{
//			$text = photoplog_regexp_text($text);
			$text = $text."...";
		}

		$text = htmlspecialchars_uni($text);

		if (empty($text))
		{
			$text = $vbphrase['photoplog_not_available'];
		}

		return $text;
	}

	if ($add_dots)
	{
		$max_len = 100;
		if ($vbulletin->options['lastthreadchars'] != 0)
		{
			$max_len = $vbulletin->options['lastthreadchars'] * 2;
		}
	}
	else
	{
		$max_len = min(vbstrlen($text),15360000);
		if ($vbulletin->options['postmaxchars'] != 0)
		{
			$max_len = $vbulletin->options['postmaxchars'];
		}
	}

	if (vbstrlen($text) > $max_len)
	{
		$text = substr($text, 0, $max_len);
		$text = photoplog_regexp_text($text);
	}

	if ($do_parseurl)
	{
		$text = convert_url_to_bbcode($text);
	}

	if ($add_dots)
	{
//		$text = photoplog_regexp_text($text);
		$text = $text."...";
	}

	if (!function_exists('fetch_tag_list') || !class_exists('vB_BbCodeParser'))
	{
		require_once(DIR . '/includes/class_bbcode.php');
	}

	$photoplog_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
	$text = $photoplog_parser->do_parse($text, $do_html, $do_smilies, $do_bbcode, $do_imgcode, true, false);

	$text = fetch_no_shouting_text($text);

	if (empty($text))
	{
		$text = $vbphrase['photoplog_not_available'];
	}

	return $text;
}

// ##################### Start photoplog_regexp_text #####################
function photoplog_regexp_text($text)
{
	$text = preg_replace("/\[.*\]/isU", " ", $text);
	$text = preg_replace("/<.*>/isU", " ", $text);
	$text = eregi_replace("(<[^>]*)$", "", $text);
	$text = eregi_replace("&[^[:space:]]*[^;]$", "", $text);
	$text = eregi_replace("\[([^]]*)$", "", $text);
	return $text;
}

// ##################### Start photoplog_list_worker ##################### 
function photoplog_list_worker(&$list_cats, $parentid, $spacer, &$catids, &$titles, &$parentids)
{
	global $vbphrase;

	if ($parentid < 0)
	{
		$list_cats = array("-1" => $vbphrase['photoplog_no_one']);
	}

	$n = count($catids);
	for ($i=0; $i<$n; $i++)
	{
		if ($parentid == $parentids[$i])
		{
			$list_cats["$catids[$i]"] = $spacer." ".$titles[$i]." ";
			if ($catids[$i] > 0)
			{
				photoplog_list_worker($list_cats, $catids[$i], $spacer.'--', $catids, $titles, $parentids);
			}
		}
	}
}

// ################### Start photoplog_list_categories ###################
function photoplog_list_categories(&$list_cats, $parentid = -1, $spacer = '')
{
	global $vbulletin;

	$categories = $vbulletin->db->query_read("SELECT *
				FROM photoplog_categories
				ORDER BY parentid,displayorder,catid
	");

	$catids = array();
	$titles = array();
	$parentids = array();

	while ($category = $vbulletin->db->fetch_array($categories))
	{
		$catids[] = intval($category['catid']);
		$titles[] = strval($category['title']);
		$parentids[] = intval($category['parentid']);
	}

	photoplog_list_worker($list_cats, $parentid, $spacer, $catids, $titles, $parentids);
}

// #################### Start photoplog_child_worker #####################
function photoplog_child_worker(&$list_imm, &$list_all, $parid = -1)
{
	$parid = intval($parid);
	$list_all[$parid] = array();

	if (!is_array($list_imm[$parid]))
	{
		$list_imm[$parid] = array();
	}

	foreach ($list_imm[$parid] as $catid)
	{
		$list_all[$parid][] = intval($catid);

		if (!isset($list_all[$catid]))
		{
			photoplog_child_worker($list_imm, $list_all, $catid);
		}

		$list_all[$parid] = array_merge($list_all[$parid], $list_all[$catid]);
	}
}

// ##################### Start photoplog_child_list ######################
function photoplog_child_list(&$list_imm, &$list_all)
{
	global $vbulletin;

	$categories = $vbulletin->db->query_read("SELECT catid, parentid
						FROM photoplog_categories");

	while ($category = $vbulletin->db->fetch_array($categories))
	{
		$catid = intval($category['catid']);
		$parid = intval($category['parentid']);

		$list_imm[$parid][] = $catid;

		if (!isset($list_imm[$catid]))
		{
			$list_imm[$catid] = array();
		}
	}

	photoplog_child_worker($list_imm, $list_all);
}

// #################### Start photoplog_index_bounce #####################
function photoplog_index_bounce()
{
	global $photoplog_location, $vbulletin;

	$photoplog_url = $photoplog_location.'/index.php'.$vbulletin->session->vars['sessionurl_q'];
	exec_header_redirect($photoplog_url);
	exit();
}

// ##################### Start photoplog_file_link #######################
function photoplog_file_link($photoplog_userid, $photoplog_fileid, $photoplog_filename)
{
	global $vbulletin;

	$photoplog_userid = intval($photoplog_userid);
	$photoplog_fileid = intval($photoplog_fileid);
	$photoplog_filename = strval($photoplog_filename);

	if ($vbulletin->options['photoplog_dynamic_link'])
	{
		$photoplog_file_olink = $vbulletin->options['photoplog_script_dir']."/file.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid."&amp;w=o";
		$photoplog_file_llink = $vbulletin->options['photoplog_script_dir']."/file.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid."&amp;w=l";
		$photoplog_file_mlink = $vbulletin->options['photoplog_script_dir']."/file.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid."&amp;w=m";
		$photoplog_file_slink = $vbulletin->options['photoplog_script_dir']."/file.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid."&amp;w=s";
	}
	else
	{
		$photoplog_file_olink = $vbulletin->options['photoplog_script_dir']."/".$vbulletin->options['photoplog_upload_dir']."/".$photoplog_userid."/".$photoplog_filename;
		$photoplog_file_llink = $vbulletin->options['photoplog_script_dir']."/".$vbulletin->options['photoplog_upload_dir']."/".$photoplog_userid."/large/".$photoplog_filename;
		$photoplog_file_mlink = $vbulletin->options['photoplog_script_dir']."/".$vbulletin->options['photoplog_upload_dir']."/".$photoplog_userid."/medium/".$photoplog_filename;
		$photoplog_file_slink = $vbulletin->options['photoplog_script_dir']."/".$vbulletin->options['photoplog_upload_dir']."/".$photoplog_userid."/small/".$photoplog_filename;
	}

	return array('o' => $photoplog_file_olink, 'l' => $photoplog_file_llink, 'm' => $photoplog_file_mlink, 's' => $photoplog_file_slink);
}

// #################### Start photoplog_output_page ######################
function photoplog_output_page($template_name, $photoplog_phrase, $error_message = '')
{
	global $photoplog_location, $photoplog_sub_navbar, $photoplog_powered_by;
	global $photoplog_fileid, $photoplog_title, $photoplog_description, $photoplog_file_catid, $photoplog_select_row;
	global $photoplog_userid, $photoplog_username, $photoplog_filename, $photoplog_filesize, $photoplog_date;
	global $photoplog_time, $photoplog_views, $photoplog_catid, $photoplog_category_title, $photoplog_random_bits;
	global $photoplog_cat_id, $photoplog_subcat_bar, $photoplog_letter_id, $photoplog_user_id, $photoplog_letter_bar;
	global $photoplog_cat_list, $photoplog_pagenav, $photoplog_file_bits, $photoplog_checked, $messagearea;
	global $photoplog_rating, $photoplog_comment, $photoplog_commentid, $editorid, $photoplog_rate_list;
	global $photoplog_rate_pagenav, $photoplog_comment_view, $photoplog_comment_make, $photoplog_comment_editown;
	global $photoplog_comment_deleteown, $photoplog_comment_editothers, $photoplog_comment_deleteothers;
	global $photoplog_do_comments, $photoplog_comment_owner, $photoplog_default_size, $photoplog_comment_raw_average;
	global $photoplog_comment_img_average, $photoplog_comments, $photoplog_maxfilesize, $photoplog_file_link;

	global $vbulletin;
	if ($vbulletin->options['photoplog_global_vars'])
	{
		$photoplog_global_vars = array();
		$photoplog_global_string = '';

		$photoplog_global_vars = explode("\n", trim($vbulletin->options['photoplog_global_vars']));
		array_walk($photoplog_global_vars, 'photoplog_trim_text', '');

		foreach ($photoplog_global_vars AS $photoplog_global_var)
		{
			global $$photoplog_global_var;
		}
	}
	global $vbphrase, $stylevar, $vbcollapse;
	global $spacer_open, $_phpinclude_output, $scriptpath, $show, $pmbox, $foruminfo, $gobutton, $spacer_close;
	global $quickchooserbits, $languagechooserbits, $admincpdir, $modcpdir, $cronimage;
	global $threadinfo, $pagenumber, $style, $headinclude, $header, $footer;
	if (FILE_VERSION >= '3.7.0')
	{
		global $notifications_total, $notifications_menubits;
	}

	if (!eregi("^(/|http://)", $stylevar['imgdir_misc']))
	{
		$photoplog_search_for = "var IMGDIR_MISC = \"".$stylevar['imgdir_misc']."\"";
		$photoplog_replace_with = "var IMGDIR_MISC = \"".$vbulletin->options['bburl']."/".$stylevar['imgdir_misc']."\"";
		$headinclude = str_replace($photoplog_search_for, $photoplog_replace_with, $headinclude);
	}
	$photoplog_base_href = "<base href=\"".$vbulletin->options['bburl']."/".$vbulletin->options['forumhome'].".php\" />\n";
	$headinclude = $photoplog_base_href.$headinclude;

	if ($vbulletin->options['homeurl'] && $GLOBALS['vbulletin']->scriptpath && !eregi("^http[s]?://",$GLOBALS['vbulletin']->scriptpath))
	{
		$GLOBALS['vbulletin']->scriptpath = eregi_replace("^(\./|/)","",$GLOBALS['vbulletin']->scriptpath);
		$GLOBALS['vbulletin']->scriptpath = $vbulletin->options['homeurl'].'/'.$GLOBALS['vbulletin']->scriptpath;
	}

	if ($photoplog_phrase == $vbphrase['photoplog_file_list'])
	{
		$photoplog_phrase = $vbphrase['photoplog_gallery'];
	}

	$navbits = array();
//	eval('$header = "' . fetch_template('header') . '";');
	$navbits[$photoplog_location.'/index.php'.$vbulletin->session->vars['sessionurl_q']] = $vbphrase['photoplog_photoplog'];
	$navbits[''] = $photoplog_phrase;
	$navbits = construct_navbits($navbits);
	$pagetitle = $vbulletin->options['hometitle']." - ".$vbphrase['photoplog_photoplog']." - ".$photoplog_phrase;
	if ($vbphrase['photoplog_photoplog'] == $photoplog_phrase)
	{
		$pagetitle = $vbulletin->options['hometitle']." - ".$vbphrase['photoplog_photoplog'];
	}
	eval('$navbar = "' . fetch_template('navbar') . '";');
//	eval('$footer = "' . fetch_template('footer') . '";');

	$photoplog_error_message = '';
	if ($error_message)
	{
		$photoplog_error_message = $vbphrase['photoplog_sorry'].", ".$vbulletin->userinfo['username'].": ".$error_message;
	}

	eval('$html = "' . fetch_template($template_name) . '";');
	eval('$photoplog_html_output = "' . fetch_template('shell_blank') . '";');

	if (defined('GET_EDIT_TEMPLATES') && defined('PHOTOPLOG_LEVEL') && PHOTOPLOG_LEVEL == 'comment')
	{
		$photoplog_search_for = '';
		$photoplog_vbversion = explode(".", FILE_VERSION);

		if ($photoplog_vbversion[0] == 3 && $photoplog_vbversion[1] == 5)
		{
			$photoplog_search_for = "<script type=\"text/javascript\" src=\"clientscript/vbulletin_textedit.js\"></script>";
		}
		else if ($photoplog_vbversion[0] == 3 && $photoplog_vbversion[1] >= 6)
		{
			$photoplog_search_for = "<script type=\"text/javascript\" src=\"clientscript/vbulletin_textedit.js?v=".$vbulletin->options['simpleversion']."\"></script>";
		}

		if ($photoplog_search_for)
		{
			$photoplog_replace_with = @file_get_contents(PHOTOPLOG_FWD . '/clientscript/vbulletin_textedit.js');

			if ($photoplog_replace_with)
			{
				if ($photoplog_vbversion[1] > 6)
				{
					$photoplog_replace_with = str_replace("'ajax.php?do=editorswitch'", "'".$vbulletin->options['photoplog_script_dir']."/ajax.php?do=editorswitch'", $photoplog_replace_with);
				}
				else
				{
					$photoplog_replace_with = str_replace("ajax.send('ajax.php", "ajax.send('".$vbulletin->options['photoplog_script_dir']."/ajax.php", $photoplog_replace_with);
				}

				$photoplog_replace_with = "<script type=\"text/javascript\">\n<!--\n".$photoplog_replace_with."\n//-->\n</script>\n";
				$photoplog_html_output = str_replace($photoplog_search_for, $photoplog_replace_with, $photoplog_html_output);
			}
		}
	}

	eval('print_output($photoplog_html_output);');
	exit();
}

?>