<?php

/**************************************************************************
PhotoPlog Lite License
===========================================================================
This software is as-is, no warranty of any kind, use at your own risk.
You are granted free use of this software. However, you are not permitted 
under any circumstances to redistribute the software, whether in whole or 
in part. Also, the 'powered by' links must remain intact and visible. Make 
sure to understand that this is *not GPL software. Do not redistribute it, 
and do not use parts of it in other software. This software is copyrighted 
in its entirety to 'calorie' a/k/a ThinkDing LLC 2005, all rights reserved.
The software author/entity are in no way responsible for your site content.
All copyright notices and 'powered by' links must not be changed or removed.
***************************************************************************/

// ####################### SET PHP ENVIRONMENT ############################
// report all errors except notice level errors
error_reporting(E_ALL & ~E_NOTICE);

if (@ini_get('safe_mode') != 1) {
	@set_time_limit(0);
	@ini_set('max_execution_time',0);
}
@ini_set('memory_limit','128M');
@ini_set('post_max_size','30M');
@ini_set('upload_max_filesize','30M');
@ini_set('magic_quotes_runtime',false);
@ini_set('magic_quotes_sybase',false);

// ######################## GRAB THE FULL PATH ############################
require_once('./config.php');

// #################### DEFINE IMPORTANT CONSTANTS ########################
// these are to bypass print_no_permission exits in vB global.php
define('THIS_SCRIPT','image');
$_REQUEST['a'] = 'ver';

// ################### PRE-CACHE TEMPLATES AND DATA #######################
// get special phrase groups
$phrasegroups = array(
	'photoplog'
);

if (defined('GET_EDIT_TEMPLATES'))
{
	$phrasegroups = array(
		'photoplog',
		'posting'
	);
}

// get special data templates from the datastore
$specialtemplates = array(
	'smiliecache',
	'bbcodecache'
);

// pre-cache templates used by all actions
$globaltemplates = array(
	'headinclude',
	'header',
	'navbar',
	'shell_blank',
	'footer',
	'STANDARD_ERROR',
	'photoplog_cat_bit',
	'photoplog_cat_list',
	'photoplog_comment_form',
	'photoplog_delete_form',
	'photoplog_edit_form',
	'photoplog_error_page',
	'photoplog_file_bit',
	'photoplog_file_list',
	'photoplog_letter_bar',
	'photoplog_rate_bit',
	'photoplog_rate_list',
	'photoplog_remove_form',
	'photoplog_search_form',
	'photoplog_subcat_bar',
	'photoplog_sub_navbar',
	'photoplog_upload_form',
	'photoplog_view_file'
);

// pre-cache templates used by specific actions
$actiontemplates = array();

// ####################### REQUIRE VB BACK-END ############################
define('PHOTOPLOG_BWD', (($getcwd = getcwd()) ? $getcwd : '.'));

chdir(PHOTOPLOG_FWD);
require_once('./global.php');
chdir(PHOTOPLOG_BWD);

// be rid of the vB global.php print_no_permission exit bypass
unset($a,$_REQUEST['a']);

if (!function_exists('print_select_row') || !function_exists('can_administer'))
{
	require_once(DIR . '/includes/adminfunctions.php');
}

// #################### INITIALIZE SOME VARIABLES #########################
define('PHOTOPLOG_SCRIPT','init');
define('PHOTOPLOG_VERSION','Lite v.2.0.7');

$photoplog_location = $vbulletin->options['photoplog_script_dir'];
// please, do not hide, change, remove, etcetera - visit www.photoplog.com for official support
$photoplog_powered_by = "<br /><div class=\"smallfont\" align=\"center\"><a href=\"http://www.photoplog.com/\">$vbphrase[photoplog_powered_by_photoplog] ".PHOTOPLOG_VERSION."</a></div>";
// visit www.photoplog.com for official support - please, do not hide, change, remove, etcetera
$photoplog_checked = $photoplog_html_output = $html = $photoplog_sub_navbar = $photoplog_fileid = $photoplog_title = '';
$photoplog_description = $photoplog_file_catid = $photoplog_select_row = $photoplog_userid = $photoplog_username = '';
$photoplog_filename = $photoplog_filesize = $photoplog_date = $photoplog_time = $photoplog_views = $photoplog_catid = '';
$photoplog_category_title = $photoplog_random_bits = $photoplog_cat_id = $photoplog_subcat_bar = '';
$photoplog_letter_id = $photoplog_user_id = $photoplog_letter_bar = $photoplog_cat_list = $photoplog_pagenav = '';
$photoplog_file_bits = $photoplog_checked = $messagearea = $photoplog_rating = $photoplog_comment = '';
$photoplog_commentid = $editorid = $photoplog_rate_list = $photoplog_rate_pagenav = $photoplog_comment_view = '';
$photoplog_comment_make = $photoplog_comment_editown = $photoplog_comment_deleteown = $photoplog_comment_editothers = '';
$photoplog_comment_deleteothers = $photoplog_do_comments = $photoplog_comment_owner = $photoplog_default_size = '';
$photoplog_comment_raw_average = $photoplog_comment_img_average = $photoplog_comments = $photoplog_maxfilesize = '';
$photoplog_file_link = '';

// ###################### SET BIT OPTION VALUES ###########################
$photoplog_categoryoptions = array(
	'allowhtml' => 1,
	'allowsmilies' => 2,
	'allowbbcode' => 4,
	'allowimgcode' => 8,
	'allowparseurl' => 16,
	'allowcomments' => 32,
	'issearchable' => 64
);

// ###################### GRAB DATASTORE VALUES ###########################
if (!defined('PHOTOPLOG_HTTPD'))
{
	$photoplog_ds_catopts = array();
	$photoplog_ds_indopts = array();

	$photoplog_ds_infos = $db->query_read("SELECT title, data
						FROM " . TABLE_PREFIX . "datastore
						WHERE title IN ('photoplog_dscat','photoplog_dsind')
	");

	while ($photoplog_ds_info = $db->fetch_array($photoplog_ds_infos))
	{
		if ($photoplog_ds_info['title'] == 'photoplog_dscat')
		{
			$photoplog_ds_catopts = unserialize($photoplog_ds_info['data']);
		}
		else if ($photoplog_ds_info['title'] == 'photoplog_dsind')
		{
			$photoplog_ds_indopts = unserialize($photoplog_ds_info['data']);
		}
	}

	$db->free_result($photoplog_ds_infos);
}

// ###################### REQUIRE PLOG BACK-END ###########################
require_once('./functions.php');
require_once('./authenticate.php');

// #################### INITIALIZE ADMIN SQL BIT ##########################
$photoplog_admin_sql1 = "AND photoplog_fileuploads.moderate = 0";
$photoplog_admin_sql2 = "AND photoplog_ratecomment.moderate = 0";

if (!function_exists('can_administer'))
{
	require_once(DIR . '/includes/adminfunctions.php');
}

if (can_administer('canadminforums'))
{
	$photoplog_admin_sql1 = "";
	$photoplog_admin_sql2 = "";
}

// ###################### CHECK FOR PLOG ACTIVE ###########################
if (!$vbulletin->options['photoplog_is_active'] && !can_administer('canadminforums'))
{
	photoplog_output_page('photoplog_error_page',$vbphrase['photoplog_error'],$vbulletin->options['photoplog_off_reason']);
}

$photoplog_off_warn = 0;
if (!$vbulletin->options['photoplog_is_active'])
{
	$photoplog_off_warn = 1;
}

// ################### INITIALIZE SUB NAVBAR LINKS ########################
$photoplog_view_link = '';
$photoplog_upload_link = '';
$photoplog_edit_link = '';
$photoplog_delete_link = '';
$photoplog_search_link = '';
$photoplog_sub_navbar = '';

$vbulletin->input->clean_array_gpc('g', array(
	'n' => TYPE_UINT
));

$photoplog_file_id = $vbulletin->GPC['n'];
$photoplog_file_info_links = '';

if (!defined('PHOTOPLOG_HTTPD'))
{
	if ($photoplog_file_id)
	{
		$photoplog_file_info_links = $db->query_first("SELECT *
							FROM photoplog_fileuploads
							WHERE fileid = ".intval($photoplog_file_id)."
							$photoplog_admin_sql1
		");
	}

	if (defined('PHOTOPLOG_USER1'))
	{
		$photoplog_view_loc = $photoplog_location.'/index.php'.$vbulletin->session->vars['sessionurl_q'];
		$photoplog_view_link = "<a href=\"".$photoplog_view_loc."\">".$vbphrase['photoplog_home']."</a>";
	}
	if (defined('PHOTOPLOG_USER2'))
	{
		$photoplog_upload_loc = $photoplog_location.'/upload.php'.$vbulletin->session->vars['sessionurl_q'];
		$photoplog_upload_link = "<a href=\"".$photoplog_upload_loc."\">".$vbphrase['photoplog_upload']."</a>";
	}
	if (defined('PHOTOPLOG_USER3') && $photoplog_file_id && $photoplog_file_info_links && $photoplog_file_info_links['userid'] == $vbulletin->userinfo['userid'])
	{
		$photoplog_edit_loc = $photoplog_location.'/edit.php?'.$vbulletin->session->vars['sessionurl'].'n='.$photoplog_file_id;
		$photoplog_edit_link = "<a href=\"".$photoplog_edit_loc."\">".$vbphrase['photoplog_edit']."</a>";
	}
	if (defined('PHOTOPLOG_USER4') && $photoplog_file_id && $photoplog_file_info_links && $photoplog_file_info_links['userid'] == $vbulletin->userinfo['userid'])
	{
		$photoplog_delete_loc = $photoplog_location.'/delete.php?'.$vbulletin->session->vars['sessionurl'].'n='.$photoplog_file_id;
		$photoplog_delete_link = "<a href=\"".$photoplog_delete_loc."\">".$vbphrase['photoplog_delete']."</a>";
	}
	if (defined('PHOTOPLOG_USER5') && $photoplog_file_id && $photoplog_file_info_links)
	{
		$photoplog_edit_loc = $photoplog_location.'/edit.php?'.$vbulletin->session->vars['sessionurl'].'n='.$photoplog_file_id;
		$photoplog_edit_link = "<a href=\"".$photoplog_edit_loc."\">".$vbphrase['photoplog_edit']."</a>";
	}
	if (defined('PHOTOPLOG_USER6') && $photoplog_file_id && $photoplog_file_info_links)
	{
		$photoplog_delete_loc = $photoplog_location.'/delete.php?'.$vbulletin->session->vars['sessionurl'].'n='.$photoplog_file_id;
		$photoplog_delete_link = "<a href=\"".$photoplog_delete_loc."\">".$vbphrase['photoplog_delete']."</a>";
	}
	if (defined('PHOTOPLOG_USER13'))
	{
		$photoplog_search_loc = $photoplog_location.'/search.php'.$vbulletin->session->vars['sessionurl_q'];
		$photoplog_search_link = "<a href=\"".$photoplog_search_loc."\">".$vbphrase['photoplog_search']."</a>";
	}
}

if ($photoplog_view_link || $photoplog_upload_link || $photoplog_edit_link || $photoplog_delete_link || $photoplog_search_link)
{
	eval('$photoplog_sub_navbar = "' . fetch_template('photoplog_sub_navbar') . '";');
}

// ###################### INITIALIZE RANDOM BITS ##########################
$photoplog_random_bits = '';
if (defined('PHOTOPLOG_RANDOM') && !defined('PHOTOPLOG_HTTPD') && !isset($_REQUEST['c']) && !isset($_REQUEST['n']) && !isset($_REQUEST['u']) && !isset($_REQUEST['q']))
{
	$photoplog_file_stats = $db->query_first("SELECT COUNT(fileid) AS num1, MAX(fileid) AS num2 FROM photoplog_fileuploads");
	$photoplog_file_stats_mid = floor($photoplog_file_stats['num1']/2);
	$photoplog_file_stats_max = intval($photoplog_file_stats['num2']);

	if (rand(0,1))
	{
		$photoplog_rand_sql = "AND fileid > 0 AND fileid <= " . intval($photoplog_file_stats_mid);
	}
	else
	{
		$photoplog_rand_sql = "AND fileid > " . intval($photoplog_file_stats_mid) . " AND fileid <= " . intval($photoplog_file_stats_max);
	}

	$photoplog_file_infos = $db->query_read("SELECT *
						FROM photoplog_fileuploads
						WHERE 1=1
						$photoplog_rand_sql
						$photoplog_admin_sql1
						ORDER BY RAND()
						LIMIT 5
	");

	$photoplog_cnt_bits = 0;
	$photoplog_row_top = '';
	$photoplog_row_bottom = '';

	while ($photoplog_file_info = $db->fetch_array($photoplog_file_infos))
	{
		$photoplog_cnt_bits++;

		$photoplog_fileid = $photoplog_file_info['fileid'];
		$photoplog_userid = $photoplog_file_info['userid'];
		$photoplog_username = $photoplog_file_info['username'];
		$photoplog_filename = $photoplog_file_info['filename'];

		$photoplog_file_link = photoplog_file_link($photoplog_userid, $photoplog_fileid, $photoplog_filename);

		$photoplog_row_top .= "
			<td class=\"alt2\" align=\"center\" width=\"20%\">
				<a href=\"".$photoplog_location."/index.php?".$vbulletin->session->vars['sessionurl']."n=".$photoplog_fileid."\">
					<img src=\"".$photoplog_file_link['s']."\" alt=\"".$vbphrase['photoplog_image']."\" title=\"".$vbphrase['photoplog_image']."\" border=\"0\" />
				</a>
			</td>
		";

		$photoplog_row_bottom .= "
			<td class=\"alt2\" align=\"center\" width=\"20%\">
				<div class=\"smallfont\">
					".$vbphrase['photoplog_posted_by']." <a href=\"".$photoplog_location."/index.php?".$vbulletin->session->vars['sessionurl']."u=".$photoplog_userid."\">".$photoplog_username."</a>
				</div>
			</td>
		";
	}

	$db->free_result($photoplog_file_infos);

	$photoplog_table_start = "
		<table class=\"tborder\" border=\"0\" cellpadding=\"".$stylevar['cellpadding']."\" cellspacing=\"".$stylevar['cellspacing']."\" align=\"center\" width=\"100%\">
		<thead>
		<tr>
			<td colspan=\"5\" class=\"thead\"><a style=\"float: ".$stylevar['right'].";\" href=\"#top\" onclick=\"return toggle_collapse('photoplog_random_bits')\"><img id=\"collapseimg_photoplog_random_bits\" src=\"".$stylevar['imgdir_button']."/collapse_thead".$vbcollapse['collapseimg_photoplog_random_bits'].".gif\" alt=\"".$vbphrase['photoplog_image']."\" title=\"".$vbphrase['photoplog_image']."\" border=\"0\" /></a>".$vbphrase['photoplog_random_thumbs']."</td>
		</tr>
		</thead>
		<tbody id=\"collapseobj_photoplog_random_bits\" style=\"".$vbcollapse['collapseobj_photoplog_random_bits']."\">
		<tr>
	";

	$photoplog_table_end = "
		</tr>
		</tbody>
		</table><br />
	";

	$photoplog_random_bits = $photoplog_table_start.$photoplog_row_top."</tr><tr>".$photoplog_row_bottom.$photoplog_table_end;

	if (!$photoplog_cnt_bits)
	{
		$photoplog_random_bits = '';
	}
}

// ####################### INITIALIZE LETTER BAR ##########################
$photoplog_letter_bar = '';
if (defined('PHOTOPLOG_RANDOM') && !defined('PHOTOPLOG_HTTPD') && !isset($_REQUEST['c']) && !isset($_REQUEST['n']))
{
	eval('$photoplog_letter_bar = "' . fetch_template('photoplog_letter_bar') . '";');
}

// #################### GRAB CATEGORY INFORMATION #########################
if (!defined('PHOTOPLOG_HTTPD'))
{
	$photoplog_list_categories = array();
	photoplog_list_categories($photoplog_list_categories);

	$photoplog_list_children = array();
	$photoplog_list_relatives = array();
	photoplog_child_list($photoplog_list_children, $photoplog_list_relatives);
}

// ##################### INITIALIZE CATEGORY BITS #########################
$photoplog_cat_bits = '';
$photoplog_cat_list = '';

if (defined('PHOTOPLOG_RANDOM') && !defined('PHOTOPLOG_HTTPD') && !isset($_REQUEST['c']) && !isset($_REQUEST['n']) && !isset($_REQUEST['u']) && !isset($_REQUEST['q']) && !isset($_REQUEST['page']))
{
	require_once('./categories.php');
}

?>